sentilo-catalog-web/src/main/java/org/sentilo/web/catalog/domain/Component.java
/*
 * Sentilo
 *
 * Original version 1.4 Copyright (C) 2013 Institut Municipal d’Informàtica, Ajuntament de
 * Barcelona. Modified by Opentrends adding support for multitenant deployments and SaaS.
 * Modifications on version 1.5 Copyright (C) 2015 Opentrends Solucions i Sistemes, S.L.
 *
 *
 * This program is licensed and may be used, modified and redistributed under the terms of the
 * European Public License (EUPL), either version 1.1 or (at your option) any later version as soon
 * as they are approved by the European Commission.
 *
 * Alternatively, you may redistribute and/or modify this program under the terms of the GNU Lesser
 * General Public License as published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied.
 *
 * See the licenses for the specific language governing permissions, limitations and more details.
 *
 * You should have received a copy of the EUPL1.1 and the LGPLv3 licenses along with this program;
 * if not, you may find them at:
 *
 * https://joinup.ec.europa.eu/software/page/eupl/licence-eupl http://www.gnu.org/licenses/ and
 * https://www.gnu.org/licenses/lgpl.txt
 */
package org.sentilo.web.catalog.domain;

import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;

import org.sentilo.common.domain.TechnicalDetails;
import org.sentilo.web.catalog.utils.CatalogUtils;
import org.sentilo.web.catalog.utils.CompoundKeyBuilder;
import org.sentilo.web.catalog.utils.Constants;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Transient;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.util.StringUtils;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;

@Document
public class Component implements FederatedResource, CatalogDocument, TenantResource, EntityResource, AlphabeticalSortable {

  private static final long serialVersionUID = 1L;

  @Id
  private String id;

  @NotBlank
  @Pattern(regexp = Constants.VALIDATION_ENTITY_NAME_REGEXP)
  private String name;

  private String description;

  @NotBlank
  private String providerId;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date createdAt;

  private String createdBy;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date updatedAt;

  private String updatedBy;

  private int mobile = Constants.MOBILE;

  private String parentId;

  private String tags;

  private Boolean publicAccess = Boolean.FALSE;

  @NotBlank
  private String componentType;

  private Location location;

  private RoutePointList routePointList;

  private String photoUrl;

  private String tenantId;

  private Set<String> tenantsAuth;

  private Set<String> tenantsMapVisible;

  private Set<String> tenantsListVisible;

  private Boolean federatedResource = Boolean.FALSE;

  private String federatedServiceId;

  // Additional info
  @JsonInclude(value = Include.NON_EMPTY)
  private Map<String, String> additionalInfo;

  @JsonInclude(value = Include.NON_NULL)
  private TechnicalDetails technicalDetails;

  /**
   * Contains a set of locations where each element is a candidate to be member of the
   * routePointList
   */
  @JsonIgnore
  @Transient
  private transient Set<Location> locationRoutePointsCandidates;

  public Component() {
    tenantsAuth = new HashSet<String>();
    tenantsListVisible = new HashSet<String>();
    tenantsMapVisible = new HashSet<String>();
  }

  public Component(final String id) {
    this();
    this.id = id;
    if (StringUtils.hasText(id)) {
      splitId();
    }
  }

  public static String buildId(final String providerId, final String name) {
    return CompoundKeyBuilder.buildCompoundKey(providerId, name);
  }

  @Override
  public boolean equals(final Object obj) {
    if (!(obj instanceof Component) || id == null) {
      return false;
    }
    final Component other = (Component) obj;
    return getId().equals(other.getId());
  }

  @Override
  public int hashCode() {
    // Hashcode return must be consistent with the equals method
    final int prime = 23;
    int result = 1;
    result = prime * result + (id == null ? 0 : id.hashCode());
    return result;
  }

  @Override
  public String getId() {
    if (!StringUtils.hasText(id) && StringUtils.hasText(name) && StringUtils.hasText(providerId)) {
      id = buildId(providerId, name);
    }

    return id;
  }

  public boolean addLocationCandidate(final Location candidate) {
    if (locationRoutePointsCandidates == null) {
      locationRoutePointsCandidates = new HashSet<Location>();
    }

    return locationRoutePointsCandidates.add(candidate);
  }

  @Override
  public String getEntityOwner() {
    return providerId;
  }

  public void setId(final String id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(final String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(final String description) {
    this.description = description;
  }

  @Override
  public Date getCreatedAt() {
    return createdAt;
  }

  @Override
  public void setCreatedAt(final Date createdAt) {
    this.createdAt = createdAt;
  }

  @Override
  public Date getUpdatedAt() {
    return updatedAt;
  }

  @Override
  public void setUpdatedAt(final Date updatedAt) {
    this.updatedAt = updatedAt;
  }

  public Location getLocation() {
    return location;
  }

  public void setLocation(final Location location) {
    this.location = location;
  }

  public int getMobile() {
    return mobile;
  }

  @JsonIgnore
  public boolean isMobileComponent() {
    return mobile == Constants.MOBILE;
  }

  @JsonIgnore
  public boolean isStaticComponent() {
    return mobile == Constants.STATIC;
  }

  public void setMobile(final int mobile) {
    this.mobile = mobile;
  }

  public String getParentId() {
    return parentId;
  }

  public void setParentId(final String parentId) {
    this.parentId = parentId;
  }

  @JsonIgnore
  public boolean isRoot() {
    return !StringUtils.hasText(parentId);
  }

  public String getTags() {
    return tags;
  }

  public List<String> getTagsAsList() {
    return CatalogUtils.tagsToStringList(tags);
  }

  public void setTags(final String tags) {
    this.tags = tags;
  }

  public Boolean getPublicAccess() {
    return publicAccess;
  }

  public void setPublicAccess(final Boolean publicAccess) {
    this.publicAccess = publicAccess;
  }

  public String getComponentType() {
    return componentType;
  }

  public void setComponentType(final String componentType) {
    this.componentType = componentType;
  }

  public String getProviderId() {
    return providerId;
  }

  public void setProviderId(final String providerId) {
    this.providerId = providerId;
  }

  public RoutePointList getRoutePointList() {
    return routePointList;
  }

  public void setRoutePointList(final RoutePointList routePointList) {
    this.routePointList = routePointList;
  }

  public String getPhotoUrl() {
    return photoUrl;
  }

  public void setPhotoUrl(final String photoUrl) {
    this.photoUrl = photoUrl;
  }

  @Override
  public String getTenantId() {
    return tenantId;
  }

  @Override
  public void setTenantId(final String tenantId) {
    this.tenantId = tenantId;
  }

  public Map<String, String> getAdditionalInfo() {
    return additionalInfo;
  }

  public void setAdditionalInfo(final Map<String, String> additionalInfo) {
    this.additionalInfo = additionalInfo;
  }

  public TechnicalDetails getTechnicalDetails() {
    return technicalDetails;
  }

  public void setTechnicalDetails(final TechnicalDetails technicalDetails) {
    this.technicalDetails = technicalDetails;
  }

  public Set<Location> getLocationCandidates() {
    return locationRoutePointsCandidates;
  }

  @Override
  public Set<String> getTenantsAuth() {
    return tenantsAuth;
  }

  @Override
  public void setTenantsAuth(final Set<String> tenantsAuth) {
    this.tenantsAuth = tenantsAuth;
  }

  @Override
  public String getCreatedBy() {
    return createdBy;
  }

  @Override
  public void setCreatedBy(final String createdBy) {
    this.createdBy = createdBy;
  }

  @Override
  public String getUpdatedBy() {
    return updatedBy;
  }

  @Override
  public void setUpdatedBy(final String updatedBy) {
    this.updatedBy = updatedBy;
  }

  public Set<String> getTenantsMapVisible() {
    return tenantsMapVisible;
  }

  public void setTenantsMapVisible(final Set<String> tenantsMapVisible) {
    this.tenantsMapVisible = tenantsMapVisible;
  }

  @Override
  public Set<String> getTenantsListVisible() {
    return tenantsListVisible;
  }

  @Override
  public void setTenantsListVisible(final Set<String> tenantsListVisible) {
    this.tenantsListVisible = tenantsListVisible;
  }

  @Override
  public String getSortableValue() {
    return name;
  }

  public void setFederatedResource(final Boolean federatedResource) {
    this.federatedResource = federatedResource;
  }

  public String getFederatedServiceId() {
    return federatedServiceId;
  }

  public void setFederatedServiceId(final String federatedServiceId) {
    this.federatedServiceId = federatedServiceId;
  }

  protected void splitId() {
    // If Id is a compound key, split it to get its parts
    final String[] tokens = CompoundKeyBuilder.splitCompoundKey(id);
    if (tokens.length == 2) {
      providerId = tokens[0];

sentilo-catalog-web/src/main/java/org/sentilo/web/catalog/domain/ComponentType.java
/*
 * Sentilo
 *
 * Original version 1.4 Copyright (C) 2013 Institut Municipal d’Informàtica, Ajuntament de
 * Barcelona. Modified by Opentrends adding support for multitenant deployments and SaaS.
 * Modifications on version 1.5 Copyright (C) 2015 Opentrends Solucions i Sistemes, S.L.
 *
 *
 * This program is licensed and may be used, modified and redistributed under the terms of the
 * European Public License (EUPL), either version 1.1 or (at your option) any later version as soon
 * as they are approved by the European Commission.
 *
 * Alternatively, you may redistribute and/or modify this program under the terms of the GNU Lesser
 * General Public License as published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied.
 *
 * See the licenses for the specific language governing permissions, limitations and more details.
 *
 * You should have received a copy of the EUPL1.1 and the LGPLv3 licenses along with this program;
 * if not, you may find them at:
 *
 * https://joinup.ec.europa.eu/software/page/eupl/licence-eupl http://www.gnu.org/licenses/ and
 * https://www.gnu.org/licenses/lgpl.txt
 */
package org.sentilo.web.catalog.domain;

import java.util.Date;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;

import org.sentilo.web.catalog.utils.Constants;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;

@Document
public class ComponentType implements CatalogDocument, AlphabeticalSortable {

  private static final long serialVersionUID = 1L;

  @NotBlank
  @Pattern(regexp = Constants.VALIDATION_ENTITY_NAME_REGEXP)
  private String id;

  @NotBlank
  private String name;

  private String description;

  @NotBlank
  private String icon;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date createdAt;

  private String createdBy;

  @DateTimeFormat(pattern = Constants.DATETIME_FORMAT)
  private Date updatedAt;

  private String updatedBy;

  private String photoUrl;

  public ComponentType(final String id) {
    this.id = id;
  }

  public ComponentType(final String id, final String name) {
    this.id = id;
    this.name = name;
    createdAt = new Date();
  }

  public ComponentType() {
  }

  @Override
  public boolean equals(final Object obj) {
    if (!(obj instanceof ComponentType)) {
      return false;
    }

    if (id == null) {
      return false;
    }

    final ComponentType other = (ComponentType) obj;
    return id.equals(other.getId());
  }

  @Override
  public int hashCode() {
    // Hashcode return must be consistent with the equals method
    final int prime = 37;
    int result = 1;
    result = prime * result + (id == null ? 0 : id.hashCode());
    return result;
  }

  @Override
  public String getId() {
    return id;
  }

  public void setId(final String id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(final String name) {
    this.name = name;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(final String description) {
    this.description = description;
  }

  @Override
  public void setUpdatedAt(final Date updatedAt) {
    this.updatedAt = updatedAt;
  }

  @Override
  public Date getUpdatedAt() {
    return updatedAt;
  }

  @Override
  public void setCreatedAt(final Date createdAt) {
    this.createdAt = createdAt;
  }

  @Override
  public Date getCreatedAt() {
    return createdAt;
  }

  public String getIcon() {
    return icon;
  }

  public void setIcon(final String icon) {
    this.icon = icon;
  }

  public String getPhotoUrl() {
    return photoUrl;
  }

  public void setPhotoUrl(final String photoUrl) {
    this.photoUrl = photoUrl;
  }

  @Override
  public String getCreatedBy() {
    return createdBy;
  }

  @Override
  public void setCreatedBy(final String createdBy) {
    this.createdBy = createdBy;
  }

  @Override
  public String getUpdatedBy() {
    return updatedBy;
  }

  @Override
  public void setUpdatedBy(final String updatedBy) {
    this.updatedBy = updatedBy;
  }

  @Override
  public String getSortableValue() {
    return name;
  }
}

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/component/component_add_components.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<spring:url value="/admin/component/${componentComponents.componentId}/detail" var="backURL" />

<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span3">
				<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
			</div>

			<div class="span9">

				<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>

				<spring:url value="/admin/component/${componentComponents.componentId}/addComponents" var="addComponentsURL" />

				<h1 class="lead">
					<spring:message code="component.assign.title" />
					<br />
				</h1>

				<form:form method="post" modelAttribute="componentComponents" action="${addComponentsURL}" class="form-horizontal">
					<fieldset>
						<div class="control-group">
							<form:label path="componentId" class="control-label">
								<spring:message code="component.id" />
							</form:label>
							<div class="controls">
								<form:input path="componentId" value="${componentId}" readonly="true" />
								<form:errors path="componentId" cssClass="error" htmlEscape="false" />
							</div>
						</div>
						<div class="control-group">
							<form:label path="selectedIds" class="control-label">
								<spring:message code="component.assign.title" />
							</form:label>
							<div class="controls">
								<form:select path="selectedIds">
									<form:options items="${componentComponents.components}" itemValue="id" itemLabel="name" />
								</form:select>
								<form:errors path="selectedIds" cssClass="error" htmlEscape="false" />
							</div>
						</div>
						<div class="control-group">
							<div class="controls">
								<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
								<button type="submit" class="btn">
									<spring:message code="component.assign.title" />
								</button>
							</div>
						</div>
					</fieldset>
				</form:form>

			</div>
		</div>
	</div>
</div>
<%@include file="/WEB-INF/jsp/common/footer.jsp"%>

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/component/component_detail.jsp
<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<spring:eval var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('READ', component)"/>

<c:set var="componentTable"  value="componentDetailComponentTable" />
<c:set var="sensorTable"  value="componentDetailSensorTable" />
<c:set var="componentId" scope="request" value="${component.id}" />

<spring:url value="/admin/component/new" var="newComponentLink" />
<spring:url value="/admin/component/delete" var="deleteURL" />
<spring:url value="/admin/component/${component.id}/edit" var="editComponentLink" />
<spring:url value="/admin/sensor/list/json?componentId=${component.id}" var="sensorsAjaxSource" />
<spring:url value="/admin/component/${component.id}/removeSensors" var="deleteSensorsURL" />
<spring:url value="/admin/component/list?nameTableRecover=componentTable&fromBack=true" var="backURL" />
<spring:url value="/admin/component/list/json?parentId=${componentId}" var="sAjaxSourceComp" />
<spring:url value="/admin/sensor/list/excel?tableName=${sensorTable}&componentId=${component.id}" var="sensorExcelSource" />


<%@include file="/WEB-INF/jsp/common/include_tab_classes.jsp"%>
<%@include file="/WEB-INF/jsp/common/include_script_maps.jsp" %>

<spring:message code="sure.delete.component" var="deleteComponentConfirmMessage" />

<c:if test="${component.staticComponent}">
	<script type="text/javascript">	
	$(document).ready(function() {
		const componentPath = '${component.location}';
		const mapOptions = {
			latitude: '${component.location.centroid[1]}',
			longitude: '${component.location.centroid[0]}',
			coordinates: componentPath.split(','),
			icon: '${componentIcon}',
			provider: '${provider_map}'
		}
		initializeMap(mapOptions);
	});
	</script>
</c:if>

<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span12">
				<div class="span3">
					<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
				</div>
				<div class="span9">

					<div class="row-fluid">
						<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>
						<%@include file="/WEB-INF/jsp/common/messages.jsp"%>

						<h1 class="lead">
							${component.name}<br /> <small><spring:message code="id" /> ${component.id}</small>
						</h1>

						<div class="tabbable">
							<ul class="nav nav-tabs">
								<li class="${tab1Class}"><a href="#tab1" data-toggle="tab"><spring:message code="component.detail.title" /></a></li>
								<li class="${tab2Class}"><a href="#tab2" data-toggle="tab"><spring:message code="technicalDetails.tab.label" /></a></li>
								<li class="${tab3Class}"><a href="#tab3" data-toggle="tab"><spring:message code="component.additionalInfo" /></a></li>
								<li class="${tab4Class}"><a href="#tab4" data-toggle="tab"><spring:message code="component.components" /></a></li>
								<li class="${tab5Class}"><a href="#tab5" data-toggle="tab"><spring:message code="sensor.list.title" /></a></li>
							</ul>
							<div class="tab-content">
								<div class="${tab1PaneClass}" id="tab1">
									<div class="accordion" id="detailAccordion">
										<div class="accordion-group">
											<div class="accordion-heading">
												<a class="accordion-toggle" data-toggle="collapse" data-parent="#detailAccordion"
													href="#detailAccordionCollapse"> <i class="icon-th"></i> <spring:message code="data" /> <i
													class="icon-chevron-down pull-right"></i> </a>
											</div>
											<div id="detailAccordionCollapse" class="accordion-body collapse in">
												<div class="accordion-inner">
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.tenantId" /> </strong>
														</div>
														<div class="span8">${component.tenantId}</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.type" /> </strong>
														</div>
														<div class="span8">
															<span class="label label-info">${component.componentType}</span>
														</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.description" /> </strong>
														</div>
														<div class="span8">${component.description}</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.providerId" /> </strong>
														</div>
														<div class="span8">${component.providerId}</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.accessType" /> </strong>
														</div>
														<div class="span8">
															<c:choose>
																<c:when test="${component.publicAccess}">
																	<spring:message code="public" />
																</c:when>
																<c:otherwise>
																	<spring:message code="private" />
																</c:otherwise>
															</c:choose>
														</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.createdAt" /> </strong>
														</div>
														<div class="span8">
															<spring:eval expression="component.createdAt" />
														</div>
													</div>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.updatedAt" /> </strong>
														</div>
														<div class="span8">
															<spring:eval expression="component.updatedAt" />
														</div>
													</div>
													<c:set value="${component.tagsAsList}" var="tags" scope="request" />
													<%@include file="/WEB-INF/jsp/common/include_detail_tags.jsp"%>
													<div class="row-fluid">
														<div class="span4">
															<strong><spring:message code="component.location" /> </strong>
														</div>
														<div class="span8">
															<span class="label label-info"> 
																<c:choose>	
																	<c:when test="${component.mobileComponent}">
																		<spring:message code="mobile" />
																	</c:when> 
																	<c:otherwise>
																		<spring:message code="static" />
																	</c:otherwise>
																</c:choose>
															</span>
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>
									<div class="row-fluid">
										<div class="span12">
											<div class="control-group pull-right">
												<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
												<c:if test="${showAdminControls and not component.federatedResource}">
												<a href="${editComponentLink }" class="btn btn-primary"> 
													<spring:message code="component.edit.title" />
												</a>
												</c:if>
											</div>
										</div>
									</div>
									<c:if test="${component.staticComponent}">
										<br />
										<div class="row-fluid">
											<div class="span12">
												<%@include file="/WEB-INF/jsp/common/include_location_map.jsp"%>
											</div>
										</div>
									</c:if>
								</div>
								<div class="${tab2PaneClass}" id="tab2">
									<div class="accordion" id="technicalDetailsAccordion">
										<c:set var="technicalDetails"  value="${component.technicalDetails}" />
										<c:set var="resourceIsComponent"  value="true" />
										<%@include file="/WEB-INF/jsp/common/include_technical_details.jsp"%>
										<br/>
										<div class="row-fluid">
											<div class="span12">
												<div class="control-group pull-right">
													<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
													<c:if test="${showAdminControls and not component.federatedResource}">
													<a href="${editComponentLink }" class="btn btn-primary">
														<spring:message code="component.edit.title" />
													</a>
													</c:if>
												</div>
											</div>
										</div>
									</div>
								</div>
								<div class="${tab3PaneClass}" id="tab3">
									<div class="accordion" id="detailAdditionalInfoAccordion">
										<c:set var="additionalInfo"  value="${component.additionalInfo}" />
										<%@include file="/WEB-INF/jsp/common/include_additional_info.jsp"%>
										<br/>
										<div class="row-fluid">
											<div class="span12">
												<div class="control-group pull-right">
													<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
													<c:if test="${showAdminControls and not component.federatedResource}">
													<a href="${editComponentLink }" class="btn btn-primary">
														<spring:message code="component.edit.title" />
													</a>
													</c:if>
												</div>
											</div>
										</div>
									</div>
								</div>
								<div class="${tab4PaneClass}" id="tab4">
									<%@include file="/WEB-INF/jsp/common/include_component_list.jsp"%>
									<div class="control-group pull-right">
										<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
										<c:if test="${showAdminControls}">
										<spring:url value="/admin/component/${component.id}/addComponents" var="addComponentsURL" />
										<a href="#" onclick="deleteSelected('components');" class="btn btn-danger">
											<spring:message	code="component.unassign.title" />
										</a>
										<a href="#" onclick="window.location.href='${addComponentsURL}';" class="btn">
											<spring:message code="component.assign.title" />
										</a>
										</c:if>
									</div>
								</div>
								<div class="${tab5PaneClass}" id="tab5">
									<%@include file="/WEB-INF/jsp/common/include_sensor_list.jsp"%>									
									<div class="control-group pull-right">
										<%@include file="/WEB-INF/jsp/common/include_input_back.jsp"%>
									</div>									
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<%@include file="/WEB-INF/jsp/common/footer.jsp"%>

sentilo-catalog-web/src/main/webapp/WEB-INF/jsp/component/component_list.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@include file="/WEB-INF/jsp/common/header.jsp"%>
<%@include file="/WEB-INF/jsp/common/taglibs.jsp"%>

<spring:eval  var="showAdminControls" expression="T(org.sentilo.web.catalog.security.SecurityUtils).showAdminControls('LIST', 'org.sentilo.web.catalog.domain.Component')"/>

<c:set var="componentTable"  value="componentTable" />

<spring:url value="/admin/component/new" var="newComponentLink" />
<spring:url value="/admin/component/list/json" var="sAjaxSourceComp" />
<spring:url value="/admin/component/delete" var="deleteURL" />
<spring:url value="/admin/component/changeAccessType" var="changeAccessTypeURL" />
<spring:url value="/admin/component/list/excel?tableName=${componentTable}" var="componentExcelSource" />

<spring:message code="sure.delete.component" var="deleteComponentConfirmMessage" />
<spring:message code="sure.change.accessType" var="changeAccessTypeConfirmMessage" />

<div class="container-fluid">
	<div class="content">
		<div class="row-fluid">
			<div class="span3">
				<%@include file="/WEB-INF/jsp/common/include_sidebar.jsp"%>
			</div>
			<div class="span9">
				<div class="row-fluid">
					<div class="span12">

						<%@include file="/WEB-INF/jsp/common/include_background_logo.jsp"%>
						<%@include file="/WEB-INF/jsp/common/messages.jsp"%>

						<h1 class="lead">
							<spring:message code="component.list.title" />
							<br />
						</h1>
						
						<%@include file="/WEB-INF/jsp/common/include_component_list.jsp"%>
						
						<c:if test="${showAdminControls}">
						<div class="control-group pull-right">
							<a href="#" onclick="deleteSelected('components','<spring:escapeBody>${deleteComponentConfirmMessage}</spring:escapeBody>');" class="btn btn-danger">
								<spring:message code="component.delete.title" /> 
							</a>
							<a href="#" onclick="changeAccessType('components', '<spring:escapeBody>${changeAccessTypeConfirmMessage}</spring:escapeBody>', 'public', '${changeAccessTypeURL}');" class="btn">							
								<spring:message code="button.accessType.change.toPublic" /> 
							</a>
							<a href="#" onclick="changeAccessType('components', '<spring:escapeBody>${changeAccessTypeConfirmMessage}</spring:escapeBody>', 'private', '${changeAccessTypeURL}');" class="btn">
								<spring:message code="button.accessType.change.toPrivate" /> 
							</a>							
							<a href="#" onclick="window.location.href='${newComponentLink}';" class="btn"> <spring:message code="component.new.title" /> </a>
						</div>
						</c:if>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<%@include file="/WEB-INF/jsp/common/footer.jsp"%>